#ifndef TIMER_H
#define TIMER_H

#include <stdint.h>

// I/O port addresses for the 8253
#define IOPORT_TIMER_CONTROL 0x43
#define IOPORT_TIMER_0 0x40

// Timer modes (refer to 8253 documentation for details)
#define TIMER_MODE_0 0x00
#define TIMER_MODE_1 0x40
#define TIMER_MODE_2 0x80
#define TIMER_MODE_3 0xC0

// Timer control bits (refer to 8253 documentation for details)
#define TIMER_CTRL_SELECT_0 0x01
#define TIMER_CTRL_SELECT_1 0x02
#define TIMER_CTRL_SELECT_2 0x04
#define TIMER_CTRL_MODE 0x30
#define TIMER_CTRL_BINARY 0x00
#define TIMER_CTRL_BCD 0x40
#define TIMER_CTRL_ONE_SHOT 0x80
#define TIMER_CTRL_CONTINOUS 0x00

// Function prototypes
void init_timer(uint32_t frequency);
void wait_us(uint32_t microseconds);

#endif /* TIMER_H */
